package cmex
{
   import flash.display.GradientType;
   import flash.display.Graphics;
   import flash.display.SpreadMethod;
   import flash.events.MouseEvent;
   import flash.geom.Matrix;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   import flash.utils.getDefinitionByName;
   import mx.binding.Binding;
   import mx.binding.BindingManager;
   import mx.binding.IBindingClient;
   import mx.binding.IWatcherSetupUtil2;
   import mx.core.IFlexModuleFactory;
   import mx.core.UIComponent;
   import mx.core.mx_internal;
   import mx.events.FlexEvent;
   import mx.events.PropertyChangeEvent;
   import mx.graphics.SolidColor;
   import spark.components.Group;
   import spark.effects.Animate;
   import spark.effects.animation.MotionPath;
   import spark.effects.animation.SimpleMotionPath;
   import spark.primitives.Rect;
   import tw.org.cmex.flex.font.Stroke;
   import tw.org.cmex.flex.font.StrokeDescriptor;
   import tw.org.cmex.flex.font.StrokeDescriptorList;
   import tw.org.cmex.flex.gd.CmexPoint;
   import tw.org.cmex.flex.gd.TrajectionLine;
   
   use namespace mx_internal;
   
   public class ExerciseCanvas extends Group implements IBindingClient
   {
      
      private static var _watcherSetupUtil:IWatcherSetupUtil2;
       
      
      private var _1951433347BASIC_BORDER:Group;
      
      private var _801274287CRISIS_CROSS_LINE:Group;
      
      private var _893740914FONT_CACHE:UIComponent;
      
      private var _104170529strokeAreaCmp:UIComponent;
      
      private var _873611605tipCmp:UIComponent;
      
      private var __moduleFactoryInitialized:Boolean = false;
      
      public const EVENT_CENTER_POSITION_CHANGED:String = "EVENT_CENTER_POSITION_CHANGED";
      
      public const EVENT_RESET:String = "RESET";
      
      public const EVENT_READY:String = "READY";
      
      public const EVENT_PRACTICE_FINISHED:String = "PRACTICE_FINISHED";
      
      public const EVENT_WRONG_ORDER:String = "WRONG_ORDER";
      
      public const EVENT_FONT_LOADED:String = "FONT_LOADED";
      
      public const EVENT_NEXT_STROKE:String = "NEXT_STROKE";
      
      public const EVENT_FREEZED:String = "FREEZED";
      
      private const EDGE_PADDING:Number = 5;
      
      private const LISTENER_LIST_MAP:Object = new Object();
      
      private var _427747957PEN_IMAGE:Class;
      
      private var _strokeList:StrokeDescriptorList;
      
      private var strokeStage:StrokeStage = null;
      
      private var _hideIndex = 0;
      
      mx_internal var _bindings:Array;
      
      mx_internal var _watchers:Array;
      
      mx_internal var _bindingsByDestination:Object;
      
      mx_internal var _bindingsBeginWithWord:Object;
      
      public function ExerciseCanvas()
      {
         var target:Object = null;
         var watcherSetupUtilClass:Object = null;
         this._427747957PEN_IMAGE = ExerciseCanvas_PEN_IMAGE;
         this._strokeList = new StrokeDescriptorList();
         this._bindings = [];
         this._watchers = [];
         this._bindingsByDestination = {};
         this._bindingsBeginWithWord = {};
         super();
         mx_internal::_document = this;
         var bindings:Array = this._ExerciseCanvas_bindingsSetup();
         var watchers:Array = [];
         target = this;
         if(_watcherSetupUtil == null)
         {
            watcherSetupUtilClass = getDefinitionByName("_cmex_ExerciseCanvasWatcherSetupUtil");
            watcherSetupUtilClass["init"](null);
         }
         _watcherSetupUtil.setup(this,function(param1:String):*
         {
            return target[param1];
         },function(param1:String):*
         {
            return ExerciseCanvas[param1];
         },bindings,watchers);
         mx_internal::_bindings = mx_internal::_bindings.concat(bindings);
         mx_internal::_watchers = mx_internal::_watchers.concat(watchers);
         this.mxmlContent = [this._ExerciseCanvas_Rect1_c(),this._ExerciseCanvas_Group2_i(),this._ExerciseCanvas_Group3_i(),this._ExerciseCanvas_UIComponent1_i(),this._ExerciseCanvas_UIComponent2_i(),this._ExerciseCanvas_UIComponent3_i()];
         this.addEventListener("mouseOver",this.___ExerciseCanvas_Group1_mouseOver);
         this.addEventListener("mouseOut",this.___ExerciseCanvas_Group1_mouseOut);
         this.addEventListener("mouseDown",this.___ExerciseCanvas_Group1_mouseDown);
         this.addEventListener("mouseMove",this.___ExerciseCanvas_Group1_mouseMove);
         this.addEventListener("mouseUp",this.___ExerciseCanvas_Group1_mouseUp);
         this.addEventListener("initialize",this.___ExerciseCanvas_Group1_initialize);
         var i:uint = 0;
         while(i < bindings.length)
         {
            Binding(bindings[i]).execute();
            i++;
         }
      }
      
      public static function set watcherSetupUtil(param1:IWatcherSetupUtil2) : void
      {
         ExerciseCanvas._watcherSetupUtil = param1;
      }
      
      override public function set moduleFactory(param1:IFlexModuleFactory) : void
      {
         super.moduleFactory = param1;
         if(this.__moduleFactoryInitialized)
         {
            return;
         }
         this.__moduleFactoryInitialized = true;
      }
      
      override public function initialize() : void
      {
         super.initialize();
      }
      
      private function init() : void
      {
         this.strokeStage = new StrokeStage(this.contentToLocal,this.contentToGlobal);
         this.enabled = false;
         this.addListener(this.EVENT_FONT_LOADED,this.createBasicUI);
         this.createBasicUI(this.strokeList);
      }
      
      private function onStrokeHideInterval() : *
      {
         var _loc1_:UIComponent = this.FONT_CACHE.getChildAt(this.FONT_CACHE.numChildren - this._hideIndex - 1) as UIComponent;
         var _loc2_:Animate = new Animate(_loc1_);
         _loc2_.duration = 5000;
         _loc2_.motionPaths = new Vector.<MotionPath>();
         _loc2_.motionPaths.push(new SimpleMotionPath("alpha",1,0));
         _loc2_.play();
         this._hideIndex++;
         if(this._hideIndex >= this.FONT_CACHE.numChildren)
         {
            this._hideIndex = 0;
         }
      }
      
      public function resume(param1:Boolean = false) : void
      {
         if(this.strokeStage != null)
         {
            this.strokeStage.setFreeze(false);
         }
         if(param1)
         {
            this.notifyListener(this.EVENT_FREEZED);
         }
      }
      
      public function pause() : void
      {
         this.strokeStage.setFreeze(true);
      }
      
      public function freezeCanvas() : void
      {
         this.pause();
         this.disableBrush();
         this.notifyListener(this.EVENT_FREEZED);
      }
      
      public function get strokeList() : StrokeDescriptorList
      {
         return this._strokeList;
      }
      
      public function set strokeList(param1:StrokeDescriptorList) : void
      {
         this._strokeList = param1;
         this.notifyListener(this.EVENT_FONT_LOADED,this.strokeList);
      }
      
      public function get isFreezed() : Boolean
      {
         return this.strokeStage.isFreezed();
      }
      
      public function set onCanvasFreeze(param1:Function) : void
      {
         this.addListener(this.EVENT_FREEZED,param1);
      }
      
      public function set onCanvasReset(param1:Function) : void
      {
         this.addListener(this.EVENT_RESET,param1);
      }
      
      public function set onNextStroke(param1:Function) : void
      {
         this.addListener(this.EVENT_NEXT_STROKE,param1);
      }
      
      public function set onReady(param1:Function) : void
      {
         this.addListener(this.EVENT_READY,param1);
      }
      
      public function set onPracticeFinished(param1:Function) : void
      {
         this.addListener(this.EVENT_PRACTICE_FINISHED,param1);
      }
      
      public function set onWrongStroke(param1:Function) : void
      {
         this.addListener(this.EVENT_WRONG_ORDER,param1);
      }
      
      public function set enableGridLine(param1:Boolean) : void
      {
         this.CRISIS_CROSS_LINE.setVisible(param1);
      }
      
      public function get enableGridLine() : Boolean
      {
         return this.CRISIS_CROSS_LINE.visible;
      }
      
      public function isPracticeFinished() : Boolean
      {
         return this.strokeList.isEOF();
      }
      
      private function onPenDown() : void
      {
         var _loc3_:UIComponent = null;
         var _loc1_:* = this.mouseX - AppStates.getInstance().margin.x;
         var _loc2_:* = this.mouseY - AppStates.getInstance().margin.y;
         if(this.strokeStage.begin(_loc1_,_loc2_))
         {
            _loc3_ = this.strokeStage.getActiveUIArea();
            this.strokeArea.addChild(_loc3_.mask);
            this.strokeArea.addChild(_loc3_);
         }
      }
      
      private function onWriting() : void
      {
         if(!this.strokeStage.hasBegun())
         {
            return;
         }
         var _loc1_:* = this.mouseX - AppStates.getInstance().margin.x;
         var _loc2_:* = this.mouseY - AppStates.getInstance().margin.y;
         var _loc3_:TrajectionLine = this.strokeStage.update(_loc1_,_loc2_);
         var _loc4_:UIComponent = this.strokeStage.getActiveUIArea();
         var _loc5_:Graphics = _loc4_.graphics;
         _loc5_.lineStyle(AppStates.PEN_SIZE,0);
         _loc3_.apply(_loc5_);
         var _loc6_:Rectangle = StrokeDescriptor.createStrokeRect(this,_loc4_);
         var _loc7_:CmexPoint = _loc3_.getInitialPoint();
         var _loc8_:CmexPoint = _loc3_.getEndPoint();
         if(!_loc6_.containsPoint(_loc7_) || !_loc6_.containsPoint(_loc8_))
         {
            trace("[Boudary collide]=>RECT: " + _loc6_ + ", init: " + _loc7_ + ", end: " + _loc8_);
            this.strokeStage.increMarginCollide();
            return;
         }
      }
      
      private function onPenUp() : void
      {
         var _loc6_:Graphics = null;
         var _loc7_:Stroke = null;
         if(!this.strokeStage.hasBegun())
         {
            return;
         }
         var _loc1_:* = this.mouseX - AppStates.getInstance().margin.x;
         var _loc2_:* = this.mouseY - AppStates.getInstance().margin.y;
         var _loc3_:TrajectionLine = this.strokeStage.update(_loc1_,_loc2_);
         var _loc4_:Boolean = this.strokeStage.end();
         var _loc5_:UIComponent = this.strokeStage.getActiveUIArea();
         if(_loc4_)
         {
            _loc5_.graphics.clear();
            _loc6_ = _loc5_.graphics;
            _loc6_.beginFill(0,1);
            this.strokeStage.getDescriptor().createStrokeGraph(_loc5_);
            _loc6_.endFill();
            _loc7_ = this.strokeList.next();
            if(_loc7_ != null)
            {
               this.strokeStage.reset(_loc7_.getDescriptor());
               this.notifyListener(this.EVENT_NEXT_STROKE,_loc7_);
            }
            else
            {
               this.freezeCanvas();
               this.notifyListener(this.EVENT_PRACTICE_FINISHED);
            }
         }
         else
         {
            this.strokeArea.removeChild(_loc5_);
            this.strokeStage.cleanStates();
            this.notifyListener(this.EVENT_WRONG_ORDER);
         }
      }
      
      private function onPenLeave() : void
      {
         var _loc1_:* = this.mouseX - AppStates.getInstance().margin.x;
         var _loc2_:* = this.mouseY - AppStates.getInstance().margin.y;
         var _loc3_:Rectangle = new Rectangle(this.x,this.y,this.width,this.height);
         if(!_loc3_.containsPoint(new Point(_loc1_ + x,_loc2_ + y)))
         {
            if(this.strokeStage.hasBegun())
            {
               if(containsElement(this.strokeStage.getActiveUIArea()))
               {
                  try
                  {
                     removeElement(this.strokeStage.getActiveUIArea());
                  }
                  catch(e:*)
                  {
                  }
               }
               this.strokeStage.cleanStates();
               this.notifyListener(this.EVENT_WRONG_ORDER);
            }
         }
      }
      
      public function clean() : void
      {
         while(this.tipCmp.numChildren > 0)
         {
            this.tipCmp.removeChildAt(0);
         }
         while(this.CRISIS_CROSS_LINE.numChildren > 0)
         {
            this.CRISIS_CROSS_LINE.removeChildAt(0);
         }
         while(this.BASIC_BORDER.numChildren > 0)
         {
            this.BASIC_BORDER.removeChildAt(0);
         }
         this.strokeArea.mask = null;
         while(this.strokeArea.numChildren > 0)
         {
            this.strokeArea.removeChildAt(0);
         }
         this.strokeList.resetCursor();
         if(this.strokeList.hasNext())
         {
            if(this.strokeStage != null)
            {
               this.strokeStage.reset(this.strokeList.next().getDescriptor());
            }
         }
         this.notifyListener(this.EVENT_RESET,this);
      }
      
      private function createBasicUI(param1:*) : void
      {
         var _loc2_:Graphics = this.CRISIS_CROSS_LINE.graphics;
         var _loc3_:Number = 16777215;
         var _loc4_:int = 2;
         var _loc5_:int = this.width / _loc4_;
         var _loc6_:int = this.height / _loc4_;
         var _loc7_:Matrix = new Matrix();
         _loc7_.createGradientBox(4,4,Math.PI / 4,2,2);
         _loc2_.lineStyle(1,_loc3_);
         _loc2_.lineGradientStyle(GradientType.LINEAR,[_loc3_,_loc3_],[1,0],[127,150],_loc7_,SpreadMethod.REPEAT);
         _loc2_.moveTo(0,AppStates.getInstance().center.y);
         _loc2_.lineTo(width,AppStates.getInstance().center.y);
         _loc2_.moveTo(AppStates.getInstance().center.x,0);
         _loc2_.lineTo(AppStates.getInstance().center.x,width);
         this.CRISIS_CROSS_LINE.visible = false;
         var _loc8_:Number = this.height;
         var _loc9_:Number = this.width;
         var _loc10_:Graphics = this.BASIC_BORDER.graphics;
         _loc10_.lineStyle(2,0);
         _loc10_.moveTo(this.EDGE_PADDING,this.EDGE_PADDING);
         _loc10_.lineTo(this.EDGE_PADDING,_loc8_ - this.EDGE_PADDING);
         _loc10_.lineTo(_loc9_ - this.EDGE_PADDING,_loc8_ - this.EDGE_PADDING);
         _loc10_.lineTo(_loc9_ - this.EDGE_PADDING,this.EDGE_PADDING);
         _loc10_.lineTo(this.EDGE_PADDING,this.EDGE_PADDING);
         _loc10_.lineStyle(1,7829367);
         _loc10_.moveTo(0,0);
         _loc10_.lineTo(_loc9_,0);
         _loc10_.lineTo(_loc9_,_loc8_);
         _loc10_.lineTo(0,_loc8_);
         _loc10_.lineTo(0,0);
         while(this.FONT_CACHE.numChildren > 0)
         {
            this.FONT_CACHE.removeChildAt(0);
         }
         this.strokeList.createOutline(this.FONT_CACHE);
         this.clean();
         this.enabled = true;
         this.notifyListener(this.EVENT_READY);
      }
      
      public function clearTip() : void
      {
         if(this.isFreezed)
         {
            return;
         }
         if(this.strokeStage.isTipDisplayed())
         {
            this.strokeStage.getTipArea().visible = false;
         }
      }
      
      public function showTip() : void
      {
         if(this.isFreezed)
         {
            return;
         }
         if(this.strokeStage.isTipDisplayed())
         {
            if(!this.strokeStage.getTipArea().visible)
            {
               this.strokeStage.getTipArea().visible = true;
            }
            return;
         }
         var _loc1_:UIComponent = this.strokeStage.getTipArea();
         var _loc2_:Stroke = this.strokeList.getCurrentStroke();
         _loc2_.drawSolidOutline(_loc1_,16152439,0.5);
         this.tipCmp.addChild(_loc1_.mask);
         this.tipCmp.addChild(_loc1_);
      }
      
      private function enableBrush() : void
      {
         if(this.isFreezed)
         {
            return;
         }
         this.cursorManager.setCursor(this.PEN_IMAGE,0,-13,-60);
      }
      
      private function disableBrush() : void
      {
         this.cursorManager.removeAllCursors();
      }
      
      private function addListener(param1:String, param2:Function) : void
      {
         if(this.LISTENER_LIST_MAP[param1] == null)
         {
            this.LISTENER_LIST_MAP[param1] = new Array();
         }
         var _loc3_:Array = this.LISTENER_LIST_MAP[param1] as Array;
         _loc3_.push(param2);
      }
      
      private function notifyListener(param1:String, param2:Object = null) : void
      {
         var _loc3_:Object = null;
         var _loc4_:Array = null;
         var _loc5_:int = 0;
         if(this.LISTENER_LIST_MAP[param1] != null)
         {
            _loc3_ = _loc3_ == null?this:param2;
            _loc4_ = this.LISTENER_LIST_MAP[param1] as Array;
            _loc5_ = 0;
            while(_loc5_ < _loc4_.length)
            {
               (_loc4_[_loc5_] as Function)(_loc3_);
               _loc5_++;
            }
         }
      }
      
      public function get strokeArea() : UIComponent
      {
         return this.strokeAreaCmp;
      }
      
      private function _ExerciseCanvas_Rect1_c() : Rect
      {
         var _loc1_:Rect = new Rect();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.fill = this._ExerciseCanvas_SolidColor1_c();
         _loc1_.initialized(this,null);
         return _loc1_;
      }
      
      private function _ExerciseCanvas_SolidColor1_c() : SolidColor
      {
         var _loc1_:SolidColor = new SolidColor();
         _loc1_.color = 11184810;
         return _loc1_;
      }
      
      private function _ExerciseCanvas_Group2_i() : Group
      {
         var _loc1_:Group = new Group();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.id = "CRISIS_CROSS_LINE";
         if(!_loc1_.document)
         {
            _loc1_.document = this;
         }
         this.CRISIS_CROSS_LINE = _loc1_;
         BindingManager.executeBindings(this,"CRISIS_CROSS_LINE",this.CRISIS_CROSS_LINE);
         return _loc1_;
      }
      
      private function _ExerciseCanvas_Group3_i() : Group
      {
         var _loc1_:Group = new Group();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.id = "BASIC_BORDER";
         if(!_loc1_.document)
         {
            _loc1_.document = this;
         }
         this.BASIC_BORDER = _loc1_;
         BindingManager.executeBindings(this,"BASIC_BORDER",this.BASIC_BORDER);
         return _loc1_;
      }
      
      private function _ExerciseCanvas_UIComponent1_i() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.id = "FONT_CACHE";
         if(!_loc1_.document)
         {
            _loc1_.document = this;
         }
         this.FONT_CACHE = _loc1_;
         BindingManager.executeBindings(this,"FONT_CACHE",this.FONT_CACHE);
         return _loc1_;
      }
      
      private function _ExerciseCanvas_UIComponent2_i() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.id = "tipCmp";
         if(!_loc1_.document)
         {
            _loc1_.document = this;
         }
         this.tipCmp = _loc1_;
         BindingManager.executeBindings(this,"tipCmp",this.tipCmp);
         return _loc1_;
      }
      
      private function _ExerciseCanvas_UIComponent3_i() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.percentWidth = 100;
         _loc1_.percentHeight = 100;
         _loc1_.id = "strokeAreaCmp";
         if(!_loc1_.document)
         {
            _loc1_.document = this;
         }
         this.strokeAreaCmp = _loc1_;
         BindingManager.executeBindings(this,"strokeAreaCmp",this.strokeAreaCmp);
         return _loc1_;
      }
      
      public function ___ExerciseCanvas_Group1_mouseOver(param1:MouseEvent) : void
      {
         this.enableBrush();
      }
      
      public function ___ExerciseCanvas_Group1_mouseOut(param1:MouseEvent) : void
      {
         this.disableBrush();
         this.onPenLeave();
      }
      
      public function ___ExerciseCanvas_Group1_mouseDown(param1:MouseEvent) : void
      {
         this.onPenDown();
      }
      
      public function ___ExerciseCanvas_Group1_mouseMove(param1:MouseEvent) : void
      {
         this.onWriting();
      }
      
      public function ___ExerciseCanvas_Group1_mouseUp(param1:MouseEvent) : void
      {
         this.onPenUp();
      }
      
      public function ___ExerciseCanvas_Group1_initialize(param1:FlexEvent) : void
      {
         this.init();
      }
      
      private function _ExerciseCanvas_bindingsSetup() : Array
      {
         var result:Array = [];
         result[0] = new Binding(this,function():Number
         {
            return AppStates.CANVAS_SIZE;
         },null,"this.width");
         result[1] = new Binding(this,function():Number
         {
            return AppStates.CANVAS_SIZE;
         },null,"this.height");
         result[2] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.x;
         },null,"FONT_CACHE.left");
         result[3] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.y;
         },null,"FONT_CACHE.top");
         result[4] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.x;
         },null,"tipCmp.left");
         result[5] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.y;
         },null,"tipCmp.top");
         result[6] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.x;
         },null,"strokeAreaCmp.left");
         result[7] = new Binding(this,function():Object
         {
            return AppStates.getInstance().margin.y;
         },null,"strokeAreaCmp.top");
         return result;
      }
      
      [Bindable(event="propertyChange")]
      public function get BASIC_BORDER() : Group
      {
         return this._1951433347BASIC_BORDER;
      }
      
      public function set BASIC_BORDER(param1:Group) : void
      {
         var _loc2_:Object = this._1951433347BASIC_BORDER;
         if(_loc2_ !== param1)
         {
            this._1951433347BASIC_BORDER = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"BASIC_BORDER",_loc2_,param1));
            }
         }
      }
      
      [Bindable(event="propertyChange")]
      public function get CRISIS_CROSS_LINE() : Group
      {
         return this._801274287CRISIS_CROSS_LINE;
      }
      
      public function set CRISIS_CROSS_LINE(param1:Group) : void
      {
         var _loc2_:Object = this._801274287CRISIS_CROSS_LINE;
         if(_loc2_ !== param1)
         {
            this._801274287CRISIS_CROSS_LINE = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"CRISIS_CROSS_LINE",_loc2_,param1));
            }
         }
      }
      
      [Bindable(event="propertyChange")]
      public function get FONT_CACHE() : UIComponent
      {
         return this._893740914FONT_CACHE;
      }
      
      public function set FONT_CACHE(param1:UIComponent) : void
      {
         var _loc2_:Object = this._893740914FONT_CACHE;
         if(_loc2_ !== param1)
         {
            this._893740914FONT_CACHE = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"FONT_CACHE",_loc2_,param1));
            }
         }
      }
      
      [Bindable(event="propertyChange")]
      public function get strokeAreaCmp() : UIComponent
      {
         return this._104170529strokeAreaCmp;
      }
      
      public function set strokeAreaCmp(param1:UIComponent) : void
      {
         var _loc2_:Object = this._104170529strokeAreaCmp;
         if(_loc2_ !== param1)
         {
            this._104170529strokeAreaCmp = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"strokeAreaCmp",_loc2_,param1));
            }
         }
      }
      
      [Bindable(event="propertyChange")]
      public function get tipCmp() : UIComponent
      {
         return this._873611605tipCmp;
      }
      
      public function set tipCmp(param1:UIComponent) : void
      {
         var _loc2_:Object = this._873611605tipCmp;
         if(_loc2_ !== param1)
         {
            this._873611605tipCmp = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"tipCmp",_loc2_,param1));
            }
         }
      }
      
      [Bindable(event="propertyChange")]
      private function get PEN_IMAGE() : Class
      {
         return this._427747957PEN_IMAGE;
      }
      
      private function set PEN_IMAGE(param1:Class) : void
      {
         var _loc2_:Object = this._427747957PEN_IMAGE;
         if(_loc2_ !== param1)
         {
            this._427747957PEN_IMAGE = param1;
            if(this.hasEventListener("propertyChange"))
            {
               this.dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,"PEN_IMAGE",_loc2_,param1));
            }
         }
      }
   }
}
