package cmex
{
   import flash.display.Graphics;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   import mx.core.UIComponent;
   import tw.org.cmex.flex.font.StrokeDescriptor;
   import tw.org.cmex.flex.gd.CmexPoint;
   import tw.org.cmex.flex.gd.TrajectionLine;
   
   class StrokeStage
   {
       
      
      private var contentToLocal:Function = null;
      
      private var contentToGlobal:Function = null;
      
      private var penMoveWeight:TrajectionLine = null;
      
      private var stdMoveWeight:TrajectionLine = null;
      
      private var lastPoint:CmexPoint = null;
      
      private var activeStrokeArea:UIComponent = null;
      
      private var sd:StrokeDescriptor = null;
      
      private var wrongStrokeOrder:Boolean = false;
      
      private var marginCollide:Number = 0;
      
      private var tipArea:UIComponent = null;
      
      private var freezed:Boolean = true;
      
      private var keyAreas:Array = null;
      
      private var _newKeys:Array;
      
      private var _index:int = 0;
      
      function StrokeStage(param1:Function, param2:Function)
      {
         super();
         this.contentToLocal = param1;
         this.contentToGlobal = param2;
      }
      
      public function reset(param1:StrokeDescriptor = null) : void
      {
         this.sd = param1;
         this.cleanStates();
      }
      
      public function cleanStates() : void
      {
         var _loc1_:Array = null;
         var _loc2_:int = 0;
         var _loc3_:TrajectionLine = null;
         var _loc4_:TrajectionLine = null;
         if(this.sd != null)
         {
            this.activeStrokeArea = this.sd.createStrokeArea();
            this.stdMoveWeight = new TrajectionLine();
            this.keyAreas = new Array();
            _loc1_ = this.sd.getGDTrajectoryCmds();
            _loc2_ = 0;
            while(_loc2_ < _loc1_.length)
            {
               _loc3_ = _loc1_[_loc2_];
               this.keyAreas[_loc2_] = _loc3_;
               _loc4_ = TrajectionLine.createInstance(this.contentToLocal(_loc3_.getInitialPoint()),this.contentToLocal(_loc3_.getEndPoint()));
               this.stdMoveWeight.add(_loc4_);
               _loc2_++;
            }
            this.keyAreas = this.keyAreas.reverse();
         }
         this.lastPoint = null;
         this.penMoveWeight = null;
         this.wrongStrokeOrder = false;
         this.tipArea = null;
         this.marginCollide = 0;
      }
      
      public function setFreeze(param1:Boolean) : void
      {
         this.freezed = param1;
      }
      
      public function isFreezed() : Boolean
      {
         return this.freezed;
      }
      
      public function getDescriptor() : StrokeDescriptor
      {
         return this.sd;
      }
      
      public function isTipDisplayed() : Boolean
      {
         return this.tipArea != null;
      }
      
      public function getTipArea() : UIComponent
      {
         if(this.tipArea != null)
         {
            return this.tipArea;
         }
         return this.tipArea = this.sd.createStrokeArea();
      }
      
      public function getWeightOfPen() : TrajectionLine
      {
         return this.penMoveWeight;
      }
      
      public function hasBegun() : Boolean
      {
         return this.lastPoint != null && !this.isFreezed();
      }
      
      public function getActiveUIArea() : UIComponent
      {
         return this.activeStrokeArea;
      }
      
      public function begin(param1:Number, param2:Number) : Boolean
      {
         var _loc4_:Point = null;
         var _loc5_:Point = null;
         if(this.isFreezed())
         {
            return false;
         }
         this.lastPoint = new CmexPoint(param1,param2);
         this.penMoveWeight = new TrajectionLine();
         var _loc3_:* = AppStates.CANVAS_SIZE / AppStates.SCALE_FACTOR * 0.8;
         this._newKeys = new Array();
         for each(_loc4_ in this.sd.tracks)
         {
            _loc5_ = new Point(_loc4_.x * _loc3_,_loc4_.y * _loc3_);
            this._newKeys.push(_loc5_);
         }
         return true;
      }
      
      public function update(param1:Number, param2:Number, param3:Graphics = null) : TrajectionLine
      {
         var _loc8_:Point = null;
         var _loc9_:* = undefined;
         var _loc10_:* = undefined;
         var _loc11_:TrajectionLine = null;
         var _loc12_:Point = null;
         var _loc13_:Point = null;
         var _loc14_:Number = NaN;
         var _loc15_:Rectangle = null;
         while(this._newKeys.length > 0)
         {
            _loc8_ = this._newKeys[0] as Point;
            _loc9_ = Math.abs(param1 - _loc8_.x);
            _loc10_ = Math.abs(param2 - _loc8_.y);
            if(_loc9_ < AppStates.PEN_SIZE && _loc10_ < AppStates.PEN_SIZE)
            {
               this._newKeys.shift();
               continue;
            }
            break;
         }
         var _loc4_:CmexPoint = new CmexPoint(param1,param2);
         var _loc5_:TrajectionLine = TrajectionLine.createInstance(this.contentToLocal(this.lastPoint),this.contentToLocal(_loc4_));
         this.penMoveWeight.add(_loc5_);
         this.lastPoint = _loc4_;
         var _loc6_:Point = _loc5_.getEndPoint().subtract(_loc5_.getInitialPoint());
         var _loc7_:Rectangle = new Rectangle(_loc5_.getInitialPoint().x,_loc5_.getInitialPoint().y,_loc6_.x,_loc6_.y);
         _loc7_.inflate(AppStates.PEN_SIZE / 2,AppStates.PEN_SIZE / 2);
         while(true)
         {
            _loc11_ = this.keyAreas.pop() as TrajectionLine;
            if(!_loc11_)
            {
               break;
            }
            _loc12_ = this.contentToGlobal(_loc11_.getDirectionVector());
            _loc12_.normalize(10);
            _loc13_ = _loc11_.getEndPoint();
            _loc14_ = 5;
            _loc15_ = new Rectangle(_loc13_.x - _loc12_.x,_loc13_.y - _loc12_.y,20,20);
            if(param3)
            {
               param3.lineStyle(3);
               param3.drawRect(_loc15_.x,_loc15_.y,_loc15_.width,_loc15_.height);
               param3.lineStyle(3,65535);
               param3.drawRect(_loc7_.x,_loc7_.y,_loc7_.width,_loc7_.height);
            }
            if(!_loc15_.intersects(_loc7_))
            {
               this.keyAreas.push(_loc11_);
               break;
            }
            trace("keyArea: " + _loc15_);
            trace("line.getEndPoint(): " + _loc5_.getEndPoint());
         }
         return _loc5_;
      }
      
      public function increMarginCollide() : Number
      {
         return ++this.marginCollide;
      }
      
      public function isWrongStrokeOrder() : Boolean
      {
         return this.wrongStrokeOrder;
      }
      
      public function end() : Boolean
      {
         var _loc1_:CmexPoint = this.getWeightOfPen().getDirectionVector();
         var _loc2_:CmexPoint = this.stdMoveWeight.getDirectionVector();
         var _loc3_:Number = _loc2_.angleBetween(_loc1_);
         var _loc4_:Number = this.getWeightOfPen().trackLength / this.stdMoveWeight.trackLength;
         if(this._newKeys.length > 0)
         {
            this.wrongStrokeOrder = true;
         }
         return !this.isWrongStrokeOrder();
      }
   }
}
