package tw.org.cmex.flex.font
{
   import flash.display.DisplayObject;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   import mx.core.UIComponent;
   import tw.org.cmex.flex.gd.CmexPoint;
   import tw.org.cmex.flex.gd.GDCommand;
   import tw.org.cmex.flex.gd.TrajectionLine;
   
   public class StrokeDescriptor
   {
       
      
      private var outlinePath:Array;
      
      private var trajectionPath:Array;
      
      private var trajWeightLine:TrajectionLine;
      
      private var lengthOfTrajections:Number = 0;
      
      private var _tracks:Array;
      
      public function StrokeDescriptor()
      {
         this._tracks = new Array();
         super();
         this.outlinePath = new Array();
         this.trajectionPath = new Array();
         this.trajWeightLine = new TrajectionLine();
      }
      
      public static function createStrokeRect(param1:UIComponent, param2:UIComponent, param3:Number = 35, param4:Number = 35) : Rectangle
      {
         var _loc5_:DisplayObject = param2.mask;
         var _loc6_:UIComponent = new UIComponent();
         _loc6_.x = 0;
         _loc6_.y = 0;
         var _loc7_:Rectangle = _loc5_.getRect(_loc6_);
         _loc7_.inflate(param3 * param1.scaleX,param4 * param1.scaleY);
         var _loc8_:Point = param1.globalToContent(new Point(_loc7_.x,_loc7_.y));
         _loc7_.x = _loc8_.x;
         _loc7_.y = _loc8_.y;
         _loc7_.width = _loc7_.width / param1.scaleX;
         _loc7_.height = _loc7_.height / param1.scaleY;
         return _loc7_;
      }
      
      public function addOutlineCmd(param1:GDCommand) : void
      {
         this.outlinePath.push(param1);
      }
      
      public function addTrack(param1:Number, param2:Number) : void
      {
         this._tracks.push(new Point(param1,param2));
      }
      
      public function addTrajectionCmd(param1:TrajectionLine) : void
      {
         this.trajWeightLine.add(param1);
         this.lengthOfTrajections = this.lengthOfTrajections + param1.getDirectionVector().distance();
         this.trajectionPath.push(param1);
      }
      
      public function getStrokeDrawingLength() : Number
      {
         return this.lengthOfTrajections;
      }
      
      public function loopThroughOutlines(param1:Function) : void
      {
         this.outlinePath.forEach(param1);
      }
      
      public function loopThroughTrajections(param1:Function) : void
      {
         this.trajectionPath.forEach(param1);
      }
      
      public function getStdTrajection() : TrajectionLine
      {
         return this.trajWeightLine;
      }
      
      public function getTrajectionWeight() : CmexPoint
      {
         return this.trajWeightLine.getDirectionVector();
      }
      
      public function createOutline() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.graphics.beginFill(16777215);
         this.createStrokeGraph(_loc1_);
         _loc1_.graphics.endFill();
         return _loc1_;
      }
      
      public function createRealOutline() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.graphics.beginFill(0);
         this.createStrokeGraph(_loc1_);
         _loc1_.graphics.endFill();
         return _loc1_;
      }
      
      public function scaleTransform(param1:Point) : void
      {
         var scaleFactor:Point = param1;
         var scaleFunc:Function = function(param1:GDCommand, param2:int, param3:Array):void
         {
            param1.scaleTransform(scaleFactor);
         };
         this.loopThroughOutlines(scaleFunc);
         this.loopThroughTrajections(scaleFunc);
         this.trajWeightLine.scaleTransform(scaleFactor);
      }
      
      public function createStrokeGraph(param1:UIComponent) : void
      {
         var lastPoint:Point = null;
         var uic:UIComponent = param1;
         lastPoint = null;
         this.loopThroughOutlines(function(param1:GDCommand, param2:int, param3:Array):void
         {
            lastPoint = param1.apply(uic.graphics,lastPoint);
         });
      }
      
      public function createStrokeAreaWithMask(param1:UIComponent) : UIComponent
      {
         this.createStrokeGraph(param1);
         var _loc2_:UIComponent = new UIComponent();
         _loc2_.mask = param1;
         return _loc2_;
      }
      
      public function createStrokeArea() : UIComponent
      {
         var _loc1_:UIComponent = new UIComponent();
         _loc1_.graphics.beginFill(16777215);
         var _loc2_:UIComponent = this.createStrokeAreaWithMask(_loc1_);
         _loc1_.graphics.endFill();
         return _loc2_;
      }
      
      public function getTrajectionDistance() : Number
      {
         var traLen:Number = NaN;
         traLen = 0;
         this.loopThroughTrajections(function(param1:TrajectionLine, param2:int, param3:Array):void
         {
            traLen = traLen + param1.getDirectionVector().length;
         });
         return traLen;
      }
      
      public function get tracks() : Array
      {
         return this._tracks;
      }
      
      public function getOutlineSize() : int
      {
         return this.outlinePath.length;
      }
      
      public function getTrajectionSize() : int
      {
         return this.trajectionPath.length;
      }
      
      public function getTrajectionAt(param1:int) : TrajectionLine
      {
         return this.trajectionPath[param1] as TrajectionLine;
      }
      
      public function getOutlineAt(param1:int) : GDCommand
      {
         return this.outlinePath[param1] as GDCommand;
      }
      
      public function getGDTrajectoryCmds() : Array
      {
         return this.trajectionPath;
      }
      
      public function getGDOutlineCmds() : Array
      {
         return this.outlinePath;
      }
      
      public function smoothTracks() : *
      {
         var _loc5_:* = undefined;
         var _loc6_:* = undefined;
         var _loc7_:* = undefined;
         var _loc8_:* = undefined;
         var _loc9_:* = undefined;
         var _loc1_:* = new Array();
         var _loc2_:* = -1;
         var _loc3_:* = -1;
         var _loc4_:* = 0;
         while(_loc4_ < this.tracks.length)
         {
            if(_loc2_ == -1)
            {
               _loc2_ = this.tracks[_loc4_].x;
               _loc3_ = this.tracks[_loc4_].y;
            }
            else
            {
               _loc5_ = this.tracks[_loc4_].x - _loc2_;
               _loc6_ = this.tracks[_loc4_].y - _loc3_;
               _loc7_ = 0;
               while(_loc7_ < 10)
               {
                  _loc8_ = _loc2_ + _loc5_ / 10 * _loc7_;
                  _loc9_ = _loc3_ + _loc6_ / 10 * _loc7_;
                  _loc1_.push(new Point(_loc8_,_loc9_));
                  _loc7_++;
               }
               _loc2_ = this.tracks[_loc4_].x;
               _loc3_ = this.tracks[_loc4_].y;
            }
            _loc4_++;
         }
         this._tracks = _loc1_;
      }
   }
}
