package tw.org.cmex.flex.font
{
   import flash.geom.Point;
   import mx.controls.Alert;
   import tw.org.cmex.flex.gd.CubicTo;
   import tw.org.cmex.flex.gd.LineTo;
   import tw.org.cmex.flex.gd.MoveTo;
   import tw.org.cmex.flex.gd.QuadTo;
   import tw.org.cmex.flex.gd.TrajectionLine;
   
   public class StrokeDescriptorBuilder
   {
       
      
      private var currSD:StrokeDescriptor;
      
      private var lastTrackTag:XML = null;
      
      public function StrokeDescriptorBuilder()
      {
         super();
         this.reset();
      }
      
      public static function buildStrokeList(param1:StrokeDescriptorList, param2:XML, param3:Point) : Boolean
      {
         var _loc6_:XML = null;
         var _loc7_:XML = null;
         var _loc8_:XML = null;
         var _loc9_:StrokeDescriptor = null;
         var _loc10_:Function = null;
         var _loc4_:StrokeDescriptorBuilder = new StrokeDescriptorBuilder();
         var _loc5_:Object = new Object();
         _loc5_["MoveTo"] = _loc4_.buildMoveTo;
         _loc5_["LineTo"] = _loc4_.buildLineTo;
         _loc5_["QuadTo"] = _loc4_.buildQuadTo;
         _loc5_["CubicTo"] = _loc4_.buildCubicTo;
         for each(_loc6_ in param2.children())
         {
            for each(_loc7_ in _loc6_.Outline.children())
            {
               _loc10_ = _loc5_[_loc7_.name()] as Function;
               if(_loc10_ == null)
               {
                  Alert.show(_loc7_.name() + " not found.","Stroke Unparsable");
                  return false;
               }
               _loc10_(_loc7_);
            }
            for each(_loc8_ in _loc6_.Track.children())
            {
               _loc4_.buildTrackingPath(_loc8_);
            }
            _loc9_ = _loc4_.buildDescriptor();
            _loc9_.scaleTransform(param3);
            param1.push(_loc9_);
            _loc4_.reset();
         }
         return true;
      }
      
      public function reset() : void
      {
         this.currSD = new StrokeDescriptor();
         this.lastTrackTag = null;
      }
      
      public function buildMoveTo(param1:XML) : void
      {
         var _loc2_:MoveTo = new MoveTo(parseFloat(param1.attribute("x")),parseFloat(param1.attribute("y")));
         this.currSD.addOutlineCmd(_loc2_);
      }
      
      public function buildLineTo(param1:XML) : void
      {
         var _loc2_:LineTo = new LineTo(parseFloat(param1.attribute("x")),parseFloat(param1.attribute("y")));
         this.currSD.addOutlineCmd(_loc2_);
      }
      
      public function buildQuadTo(param1:XML) : void
      {
         var _loc2_:QuadTo = new QuadTo(parseFloat(param1.attribute("x1")),parseFloat(param1.attribute("y1")),parseFloat(param1.attribute("x2")),parseFloat(param1.attribute("y2")));
         this.currSD.addOutlineCmd(_loc2_);
      }
      
      public function buildCubicTo(param1:XML) : void
      {
         var _loc2_:CubicTo = new CubicTo(parseFloat(param1.attribute("x1")),parseFloat(param1.attribute("y1")),parseFloat(param1.attribute("x2")),parseFloat(param1.attribute("y2")),parseFloat(param1.attribute("x3")),parseFloat(param1.attribute("y3")));
         this.currSD.addOutlineCmd(_loc2_);
      }
      
      public function buildTrackingPath(param1:XML) : void
      {
         var _loc4_:Number = NaN;
         var _loc5_:TrajectionLine = null;
         var _loc2_:Number = parseFloat(param1.attribute("x"));
         var _loc3_:Number = parseFloat(param1.attribute("y"));
         this.currSD.addTrack(_loc2_,_loc3_);
         if(this.lastTrackTag != null)
         {
            _loc4_ = parseFloat(param1.attribute("size"));
            if(isNaN(_loc4_))
            {
               _loc4_ = -1;
            }
            _loc5_ = new TrajectionLine(parseFloat(this.lastTrackTag.attribute("x")),parseFloat(this.lastTrackTag.attribute("y")),parseFloat(param1.attribute("x")),parseFloat(param1.attribute("y")),_loc4_);
            this.currSD.addTrajectionCmd(_loc5_);
         }
         this.lastTrackTag = param1;
      }
      
      public function buildDescriptor() : StrokeDescriptor
      {
         this.currSD.smoothTracks();
         return this.currSD;
      }
   }
}
