package tw.org.cmex.flex.font
{
   import mx.core.UIComponent;
   
   public dynamic class StrokeDescriptorList extends Array
   {
       
      
      private var activeStrokeIndex:int = -1;
      
      public function StrokeDescriptorList(param1:int = 0)
      {
         super(param1);
      }
      
      public function clone() : StrokeDescriptorList
      {
         var _loc1_:StrokeDescriptorList = new StrokeDescriptorList(this.length);
         var _loc2_:int = 0;
         while(_loc2_ < this.length)
         {
            _loc1_[_loc2_] = this[_loc2_];
            _loc2_++;
         }
         return _loc1_;
      }
      
      public function createOutline(param1:UIComponent, param2:Function = null) : void
      {
         var uic:UIComponent = param1;
         var decorateFunc:Function = param2;
         if(decorateFunc == null)
         {
            decorateFunc = function(param1:UIComponent):UIComponent
            {
               return param1;
            };
         }
         this.forEach(function(param1:StrokeDescriptor, param2:Number, param3:Array):void
         {
            uic.addChild(decorateFunc(param1.createOutline()));
         });
      }
      
      private function checkBoundary(param1:int) : Boolean
      {
         return param1 < this.length && param1 >= 0;
      }
      
      public function getPreviousStroke() : Stroke
      {
         return !!this.checkBoundary(this.activeStrokeIndex - 1)?new Stroke(this[this.activeStrokeIndex - 1]):null;
      }
      
      public function getCurrentStroke() : Stroke
      {
         return !!this.checkBoundary(this.activeStrokeIndex)?new Stroke(this[this.activeStrokeIndex]):null;
      }
      
      public function getCurrentStrokeDescriptor() : StrokeDescriptor
      {
         return !!this.checkBoundary(this.activeStrokeIndex)?this[this.activeStrokeIndex]:null;
      }
      
      public function getCurrentIndex() : int
      {
         return this.activeStrokeIndex;
      }
      
      public function getNextStroke() : Stroke
      {
         return !!this.hasNext()?new Stroke(this[this.activeStrokeIndex + 1]):null;
      }
      
      public function hasNext() : Boolean
      {
         return this.checkBoundary(this.activeStrokeIndex + 1);
      }
      
      public function hasPrevious() : Boolean
      {
         return this.checkBoundary(this.activeStrokeIndex - 1);
      }
      
      public function previous() : Stroke
      {
         return !!this.hasPrevious()?new Stroke(this[--this.activeStrokeIndex]):null;
      }
      
      public function next() : Stroke
      {
         return !!this.hasNext()?new Stroke(this[++this.activeStrokeIndex]):null;
      }
      
      public function resetCursor() : void
      {
         this.activeStrokeIndex = -1;
      }
      
      public function isEOF() : Boolean
      {
         return this.activeStrokeIndex >= this.length;
      }
   }
}
