package tw.org.cmex.flex.gd
{
   import cmex.AppStates;
   import flash.display.Graphics;
   import flash.geom.Point;
   
   public class TrajectionLine extends GDCommand
   {
       
      
      private var p1:CmexPoint = null;
      
      private var p2:CmexPoint = null;
      
      public var sizeValue:Number = 0;
      
      public var trackLength:Number = 0;
      
      public function TrajectionLine(param1:Number = 0, param2:Number = 0, param3:Number = 0, param4:Number = 0, param5:Number = -1)
      {
         super();
         this.p1 = new CmexPoint(param1,param2);
         this.p2 = new CmexPoint(param3,param4);
         this.trackLength = this.getDirectionVector().length;
         this.sizeValue = param5;
      }
      
      public static function createInstance(param1:Point, param2:Point, param3:Number = -1) : TrajectionLine
      {
         return new TrajectionLine(param1.x,param1.y,param2.x,param2.y,param3);
      }
      
      public function toAnimatePath(param1:int) : Array
      {
         var _loc7_:TrajectionLine = null;
         var _loc2_:Point = this.getDirectionVector();
         _loc2_.normalize(param1);
         var _loc3_:Number = Math.ceil(this.getDirectionVector().length / _loc2_.length);
         var _loc4_:Array = new Array();
         var _loc5_:Point = this.p1;
         var _loc6_:int = 0;
         while(_loc6_ < _loc3_)
         {
            _loc7_ = TrajectionLine.createInstance(_loc5_,_loc5_ = _loc5_.add(_loc2_),this.sizeValue);
            _loc4_[_loc6_] = _loc7_;
            _loc6_++;
         }
         return _loc4_;
      }
      
      override public function scaleTransform(param1:Point) : void
      {
         this.p1 = this.p1.multiply(param1);
         this.p2 = this.p2.multiply(param1);
      }
      
      public function applyCircle(param1:Graphics, param2:Point = null) : Point
      {
         var _loc3_:Number = AppStates.PEN_SIZE;
         if(this.sizeValue > 0)
         {
            _loc3_ = _loc3_ * (this.sizeValue / 100);
         }
         trace(_loc3_);
         param1.beginFill(0);
         param1.drawEllipse(this.p1.x,this.p1.y,_loc3_,_loc3_);
         param1.endFill();
         return this.p2;
      }
      
      override public function apply(param1:Graphics, param2:Point = null) : Point
      {
         param1.beginFill(0);
         param1.moveTo(this.p1.x,this.p1.y);
         param1.lineTo(this.p2.x,this.p2.y);
         param1.endFill();
         return this.p2;
      }
      
      public function getInitialPoint() : CmexPoint
      {
         return this.p1;
      }
      
      public function getEndPoint() : CmexPoint
      {
         return this.p2;
      }
      
      public function getDirectionVector() : CmexPoint
      {
         return CmexPoint.createByPoint(this.p2.subtract(this.p1));
      }
      
      public function diff(param1:TrajectionLine) : TrajectionLine
      {
         var _loc2_:Point = this.p1.subtract(param1.p1);
         var _loc3_:Point = this.p2.subtract(param1.p2);
         return new TrajectionLine(_loc2_.x,_loc2_.y,_loc3_.x,_loc3_.y);
      }
      
      public function add(param1:TrajectionLine) : void
      {
         this.p1.x = this.p1.x + param1.p1.x;
         this.p1.y = this.p1.y + param1.p1.y;
         this.p2.x = this.p2.x + param1.p2.x;
         this.p2.y = this.p2.y + param1.p2.y;
         this.trackLength = this.trackLength + param1.trackLength;
      }
      
      public function toString() : String
      {
         return "p1" + this.p1 + ", p2" + this.p2;
      }
   }
}
